package hero.client.grapheditor;

import hero.util.BonitaClient;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ToolTipManager;

public class Frame extends JFrame{

	private final String CLOSE = "close";
	private  String project =null;
	WFManager manager;
	WFPersistence persistence;
	WFGraph wfGraph;
	JLabel statusBar = new JLabel("Workflow editor");
	JScrollPane scrollPane=null;
	public Frame(){}
    
	public Frame(String managerProject, BonitaClient soapclient){
	try{
		//	java.awt.Frame f = new java.awt.Frame();
		//	SplashWindow sw = new SplashWindow(f,this);	
	    
		persistence = new WFPersistence(managerProject,soapclient);
	    
		manager= new WFManager(this,persistence);
	    
		getContentPane().removeAll();
	    
		this.setJMenuBar(new WFMenuBar(this,manager));
	    
	    this.project=managerProject;
	    
		//	JGraph graph = new JGraph();
		wfGraph = new WFGraph(manager,persistence);
	    
		wfGraph.setEditable(false);
	    
		//Register ToolTip
		ToolTipManager.sharedInstance().registerComponent(wfGraph);
		ToolTipManager.sharedInstance().setInitialDelay(100);
	    
		scrollPane = new JScrollPane(wfGraph);
	    
		manager.setWFGraph(wfGraph);
	    
		WFToolBar toolBar = new WFToolBar(this,manager);
		WFToolBar2 toolBar2 = new WFToolBar2(this,manager);
	    
	    
		JPanel toolPanel = new JPanel();
		toolPanel.setLayout(new BorderLayout());
	    
		toolPanel.add(scrollPane, BorderLayout.CENTER);
		toolPanel.add(toolBar2, BorderLayout.NORTH);
	    
	    
		statusBar.setBorder(BorderFactory.createLoweredBevelBorder());
		getContentPane().add(toolBar, BorderLayout.NORTH);
		getContentPane().add(toolPanel, BorderLayout.CENTER);
		getContentPane().add(statusBar, BorderLayout.SOUTH);
	    
		pack();
		Dimension screenSize =Toolkit.getDefaultToolkit().getScreenSize();
		Dimension dim = getPreferredSize();
		setLocation(screenSize.width/2 - (dim.width/2),
			screenSize.height/2 - (dim.height/2));
		this.setTitle("Workflow Graph Editor");
	    
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
			  firePropertyChange(CLOSE, "", project);
			  manager.exit();
			}
		});
	    
		manager.openProject(managerProject);      
	}catch(Exception ex){ex.printStackTrace();}

	}

	public void setStatusBar(String info){
	statusBar.setText(info);
	}

	public JScrollPane getScrollPane(){
	return scrollPane;
	}
}

