package hero.client.grapheditor;

import java.awt.Color;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JColorChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;


public class WFContextMenu {
    
    public static JPopupMenu popupMenu(final JFrame frame, final Point p,final String nodeName,final WFManager manager){

	JPopupMenu menu = new JPopupMenu();    	
	JMenuItem mi;
	WFPersistence persistence= manager.getPersistence();
	boolean buttonState = manager.getPersistence().hasPermission();
	ClassLoader cl = frame.getClass().getClassLoader();

	if(nodeName!=null){  //BnNode Options

	    JMenu order = (JMenu) menu.add(new JMenu("Order"));
	    
	    mi =(JMenuItem) order.add(new JMenuItem("To Front"));   
	    mi.setIcon(new ImageIcon(cl.getResource("images/Forward.gif")));
	    mi.addActionListener (new ActionListener () {
		    public void actionPerformed (ActionEvent e) {
				manager.getGraph().toFront(nodeName);
		    }
		});
	    
	    mi = (JMenuItem) order.add(new JMenuItem("To Back"));        
	    mi.setIcon(new ImageIcon(cl.getResource("images/Backward.gif")));
	    mi.addActionListener (new ActionListener () {
		    public void actionPerformed (ActionEvent e) {
			manager.getGraph().toBack(nodeName);
		    }
		});
	    
	    menu.addSeparator();
/*	    
	    JMenu info = (JMenu) menu.add(new JMenu("Info..."));
	    try {
		mi = (JMenuItem) info.add(new JMenuItem("State: " + persistence.getState(nodeName)));
		mi.setEnabled(false);
		mi.setBackground(Color.white);
		
		mi = (JMenuItem) info.add(new JMenuItem("Type: " + persistence.getType(nodeName)));
		mi.setEnabled(false);
		mi.setBackground(Color.white);
		
		mi = (JMenuItem) info.add(new JMenuItem("BnRole: " + persistence.getRole(nodeName)));
		mi.setEnabled(false);
		mi.setBackground(Color.white);
		
		mi = (JMenuItem) info.add(new JMenuItem("DeadLine: " + persistence.getDeadline(nodeName)));
		mi.setEnabled(false);
		mi.setBackground(Color.white);
	    }catch (Exception e){};
*/	
        mi = (JMenuItem) menu.add(new JMenuItem("Add Property")); 
		mi.setEnabled(buttonState);
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {   		      
			manager.addProperty(nodeName); 
			}
		});
		
		mi = (JMenuItem) menu.add(new JMenuItem("New Hook")); 
				mi.setEnabled(buttonState);
				mi.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {   		      
					manager.setNodeHook(nodeName); 
					}
		});
    
	    mi = (JMenuItem) menu.add(new JMenuItem("Edit Activity")); 
	    mi.setEnabled(buttonState);
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.editNode(nodeName); 
		    }
		});
	
	
	}else{
	    menu.addSeparator();	    
	    mi = (JMenuItem) menu.add(new JMenuItem("Background"));
	    mi.addActionListener (new ActionListener () {
		    public void actionPerformed (ActionEvent e) {
			Color newColor = JColorChooser.showDialog(null,
								  "Choose Background Color", manager.getGraphBackground());
			manager.setGraphBackground(newColor);
		    }
		});
	    
	    
	    menu.addSeparator();
	    
	    mi = (JMenuItem) menu.add(new JMenuItem("New BnUser")); 
	    mi.setIcon(new ImageIcon(cl.getResource("images/User.gif")));
	    mi.setEnabled(buttonState);
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.newUser();
		    }
		});
	    mi = (JMenuItem) menu.add(new JMenuItem("Users In BnProject")); 
	    mi.setIcon(new ImageIcon(cl.getResource("images/User2.gif")));
	    mi.setEnabled(buttonState);
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.usersInProject();
		    }
		});
		
		
	    menu.addSeparator();
	    
	    mi = (JMenuItem) menu.add(new JMenuItem("Add role")); 
	    mi.setIcon(new ImageIcon(cl.getResource("images/Role2.gif")));
	    mi.setEnabled(buttonState);
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.newRole();
		    }
		});
	    
	    mi = (JMenuItem) menu.add(new JMenuItem("Add user role")); 
	    mi.setIcon(new ImageIcon(cl.getResource("images/Role.gif")));
	    mi.setEnabled(buttonState);
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.addUserToRole();
		    }
		});
	    
	}
	return menu;
	

    }
    
}

